Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxsync.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxsync.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxsync.c
@@ -54,54 +54,138 @@
 #include "dmxsync.h"
 #include "dmxstat.h"
 #include "dmxlog.h"
+#include "dmxextension.h"
+#include "dmxscrinit.h"
 #include <sys/time.h>
 
 static int        dmxSyncInterval = 100; /* Default interval in milliseconds */
-static OsTimerPtr dmxSyncTimer;
-static int        dmxSyncPending;
+static OsTimerPtr dmxSyncTimer = NULL;
+static OsTimerPtr dmxActiveSyncTimer = NULL;
+static int        dmxSyncPending = 0;
+static int        dmxSyncRequest = 0;
+
+#define DMX_SELECT_TIMEOUT_SECS 5
+
+/* dispatch all pending back-end server responses */
+void
+dmxDispatch (void)
+{
+    int i;
+
+    for (i = 0; i < dmxNumScreens; i++)
+	if (dmxScreens[i].alive)
+	    dmxBEDispatch (screenInfo.screens[i]);
+}
+
+/* non-blocking wait for back-end server response. returns 0 when no
+   more reponses can arrive */
+int
+dmxWaitForResponse (void)
+{
+    fd_set rfds;
+    int    nfd = 0;
+    int    i, ret = 0;
+
+    FD_ZERO (&rfds);
+     
+    for (i = 0; i < dmxNumScreens; i++)
+    {
+	if (dmxScreens[i].alive)
+	{
+	    xcb_flush (dmxScreens[i].connection);
+
+	    if (xcb_connection_has_error (dmxScreens[i].connection))
+	    {
+		dmxScreens[i].alive = FALSE;
+		ret = -1;
+	    }
+	    else
+	    {
+		FD_SET (dmxScreens[i].fd, &rfds);
+
+		if (dmxScreens[i].fd > nfd)
+		    nfd = dmxScreens[i].fd;
+	    }
+	}
+    }
+
+    if (ret == 0 && nfd)
+    {
+	do {
+	    struct timeval timeout;
+
+	    timeout.tv_sec  = DMX_SELECT_TIMEOUT_SECS;
+	    timeout.tv_usec = 0;
+
+	    ret = select (nfd + 1, &rfds, 0, 0, &timeout);
+	} while (ret == -1 && errno == EINTR);
+
+	if (!ret)
+	{
+	    for (i = 0; i < dmxNumScreens; i++)
+	    {
+		if (dmxScreens[i].alive && dmxScreens[i].request.head)
+		{
+		    xcb_disconnect (dmxScreens[i].connection);
+		    dmxScreens[i].alive = FALSE;
+		}
+	    }
+	}
+
+	/* screens with broken connections are detached in the
+	   block handler */
+    }
+
+    return nfd;
+}
 
 static void dmxDoSync(DMXScreenInfo *dmxScreen)
 {
     dmxScreen->needsSync = FALSE;
 
-    if (!dmxScreen->beDisplay)
+    if (!dmxScreen->alive)
 	return; /* FIXME: Is this correct behavior for sync stats? */
 
-    if (!dmxStatInterval) {
-        XSync(dmxScreen->beDisplay, False);
-    } else {
-        struct timeval start, stop;
-        
-        gettimeofday(&start, 0);
-        XSync(dmxScreen->beDisplay, False);
-        gettimeofday(&stop, 0);
-        dmxStatSync(dmxScreen, &stop, &start, dmxSyncPending);
-    }
+    if (dmxScreen->sync.sequence)
+	return;
+
+    dmxScreen->sync = xcb_get_input_focus (dmxScreen->connection);
+    dmxAddRequest (&dmxScreen->request,
+		   dmxScreenSyncReply,
+		   dmxScreen->sync.sequence,
+		   0);
+    dmxSyncRequest++;
 }
 
 static CARD32 dmxSyncCallback(OsTimerPtr timer, CARD32 time, pointer arg)
 {
-    int           i;
+    int i;
 
-    if (dmxSyncPending) {
-        for (i = 0; i < dmxNumScreens; i++) {
-            DMXScreenInfo *dmxScreen = &dmxScreens[i];
-            if (dmxScreen->needsSync) dmxDoSync(dmxScreen);
-        }
+    /* make sure TimerFree is not called from while waiting for
+       pending replies */
+    dmxActiveSyncTimer = NULL;
+
+    /* wait for all pending sync replies */
+    do {
+	dmxDispatch ();
+    } while (dmxSyncRequest && dmxWaitForResponse ());
+
+    if (dmxSyncPending)
+    {
+	for (i = 0; i < dmxNumScreens; i++)
+	    if (dmxScreens[i].needsSync)
+		dmxDoSync (&dmxScreens[i]);
+
+	dmxSyncPending = 0;
+
+	if (dmxSyncRequest)
+	{
+	    dmxActiveSyncTimer = timer;
+	    return dmxSyncInterval;
+	}
     }
-    dmxSyncPending = 0;
-    return 0;                   /* Do not place on queue again */
-}
-
-static void dmxSyncBlockHandler(pointer blockData, OSTimePtr pTimeout,
-                                pointer pReadMask)
-{
-    TimerForce(dmxSyncTimer);
-}
 
-static void dmxSyncWakeupHandler(pointer blockData, int result,
-                                 pointer pReadMask)
-{
+    return 0;                   /* Do not place on queue again */
 }
 
 /** Request the XSync() batching optimization with the specified \a
@@ -124,9 +208,6 @@ void dmxSyncActivate(const char *interva
 void dmxSyncInit(void)
 {
     if (dmxSyncInterval) {
-        RegisterBlockAndWakeupHandlers(dmxSyncBlockHandler,
-                                       dmxSyncWakeupHandler,
-                                       NULL);
         dmxLog(dmxInfo, "XSync batching with %d ms interval\n",
                dmxSyncInterval);
     } else {
@@ -159,35 +240,82 @@ void dmxSync(DMXScreenInfo *dmxScreen, B
              * 2) freed, if it was on a queue (dmxSyncPending != 0), or
              * 3) allocated, if it wasn't on a queue (dmxSyncPending == 0)
              */
-            if (dmxSyncTimer && !dmxSyncPending) xfree(dmxSyncTimer);
+            if (dmxSyncTimer && !dmxActiveSyncTimer) xfree(dmxSyncTimer);
             dmxSyncTimer  = NULL;
-            now           = TRUE;
+            now           = FALSE;
             dmxGeneration = serverGeneration;
         }
-                                /* Queue sync */
+
+	/* Queue sync */
         if (dmxScreen) {
+	    if (now && dmxScreen->inDispatch)
+	    {
+		dmxLog (dmxWarning,
+			"Immediate sync from within back-end dispatch\n");
+		free (xcb_get_input_focus_reply
+		      (dmxScreen->connection,
+		       xcb_get_input_focus (dmxScreen->connection),
+		       NULL));
+		return;
+	    }
             dmxScreen->needsSync = TRUE;
             ++dmxSyncPending;
         }
 
-                                /* Do sync or set time for later */
-        if (now || !dmxScreen) {
-            if (!TimerForce(dmxSyncTimer)) dmxSyncCallback(NULL, 0, NULL);
-            /* At this point, dmxSyncPending == 0 because
-             * dmxSyncCallback must have been called. */
-            if (dmxSyncPending)
-                dmxLog(dmxFatal, "dmxSync(%s,%d): dmxSyncPending = %d\n",
-                       dmxScreen ? dmxScreen->name : "", now, dmxSyncPending);
-        } else {
-            dmxScreen->needsSync = TRUE;
-            if (dmxSyncPending == 1)
-                dmxSyncTimer = TimerSet(dmxSyncTimer, 0, dmxSyncInterval,
-                                        dmxSyncCallback, NULL);
+	/* Do sync or set time for later */
+        if (now || !dmxScreen)
+	{
+	    if (dmxActiveSyncTimer)
+	    {
+		TimerCancel (dmxActiveSyncTimer);
+		dmxActiveSyncTimer = NULL;
+	    }
+
+	    while (dmxSyncRequest || dmxSyncPending)
+		dmxSyncCallback (NULL, 0, NULL);
         }
-    } else {
-                                /* If dmxSyncInterval is not being used,
-                                 * then all the backends are already
-                                 * up-to-date. */
-        if (dmxScreen) dmxDoSync(dmxScreen);
+	else if (!dmxActiveSyncTimer)
+	{
+	    dmxActiveSyncTimer = TimerSet (dmxSyncTimer,
+					   0,
+					   dmxSyncInterval,
+					   dmxSyncCallback,
+					   NULL);
+	}
+    }
+    else
+    {
+	/* If dmxSyncInterval is not being used,
+	 * then all the backends are already
+	 * up-to-date. */
+        if (dmxScreen)
+	{
+	    dmxDoSync (dmxScreen);
+	    dmxSyncCallback (NULL, 0, NULL);
+	}
+    }
+}
+
+/* error or reply doesn't matter, all we need is some response
+   from the back-end server */
+void
+dmxScreenSyncReply (ScreenPtr           pScreen,
+		    unsigned int        sequence,
+		    xcb_generic_reply_t *reply,
+		    xcb_generic_error_t *error,
+		    void                *data)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    if (dmxScreen->sync.sequence)
+    {
+	dmxScreen->sync.sequence = 0;
+	dmxSyncRequest--;
+
+	if (dmxSyncRequest == 0 && dmxSyncPending == 0 && dmxActiveSyncTimer)
+	{
+	    TimerCancel (dmxActiveSyncTimer);
+	    dmxActiveSyncTimer = NULL;
+	}
     }
 }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxsync.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxsync.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxsync.h
@@ -37,7 +37,14 @@
 #ifndef _DMXSYNC_H_
 #define _DMXSYNC_H_
 
+extern void dmxDispatch (void);
+extern int  dmxWaitForResponse (void);
 extern void dmxSyncActivate(const char *interval);
 extern void dmxSyncInit(void);
 extern void dmxSync(DMXScreenInfo *dmxScreen, Bool now);
+extern void dmxScreenSyncReply (ScreenPtr           pScreen,
+				unsigned int        sequence,
+				xcb_generic_reply_t *reply,
+				xcb_generic_error_t *error,
+				void                *data);
 #endif
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxvisual.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxvisual.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxvisual.c
@@ -92,8 +92,8 @@ Visual *dmxLookupVisual(ScreenPtr pScree
 
     for (i = 0; i < dmxScreen->beNumVisuals; i++) {
 	if (pVisual->class == dmxScreen->beVisuals[i].class &&
-	    pVisual->bitsPerRGBValue == dmxScreen->beVisuals[i].bits_per_rgb &&
-	    pVisual->ColormapEntries == dmxScreen->beVisuals[i].colormap_size &&
+	    pVisual->bitsPerRGBValue <= dmxScreen->beVisuals[i].bits_per_rgb &&
+	    pVisual->ColormapEntries <= dmxScreen->beVisuals[i].colormap_size &&
 	    pVisual->nplanes == dmxScreen->beVisuals[i].depth &&
 	    pVisual->redMask == dmxScreen->beVisuals[i].red_mask &&
 	    pVisual->greenMask == dmxScreen->beVisuals[i].green_mask &&
